Package io.vertx.rxjava3.core.eventbus

## Class MessageConsumer<T>

- java.lang.Object
- - io.vertx.rxjava3.core.eventbus.MessageConsumer<T>

- All Implemented Interfaces:
    `io.vertx.lang.rx.RxDelegate`, `ReadStream<Message<T>>`, `StreamBase`

      public class MessageConsumer<T>
      extends Object
      implements io.vertx.lang.rx.RxDelegate, ReadStream<Message<T>>

  An event bus consumer object representing a stream of message to an `EventBus` address that can be read from.

  The `EventBus.consumer(io.vertx.core.eventbus.MessageConsumerOptions)` or `EventBus.localConsumer(java.lang.String)` creates a new consumer, the returned consumer is not yet registered against the event bus. Registration is effective after the `handler(io.vertx.core.Handler<io.vertx.rxjava3.core.eventbus.Message<T>>)` method is invoked.

  The consumer is unregistered from the event bus using the `unregister()` method or by calling the `handler(io.vertx.core.Handler<io.vertx.rxjava3.core.eventbus.Message<T>>)` with a null value..

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<MessageConsumer>` | `__TYPE_ARG` |
    `io.vertx.lang.rx.TypeArg<T>` | `__typeArg_0` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `MessageConsumer​(MessageConsumer delegate)` |
    `MessageConsumer​(Object delegate, io.vertx.lang.rx.TypeArg<T> typeArg_0)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `String` | `address()` |
    `ReadStream<T>` | `bodyStream()` |
    `Completable` | `completion()` |
    `MessageConsumer<T>` | `endHandler​(Handler<Void> endHandler)` | Set an end handler.
    `boolean` | `equals​(Object o)` |
    `MessageConsumer<T>` | `exceptionHandler​(Handler<Throwable> handler)` | Set an exception handler on the read stream.
    `MessageConsumer<T>` | `fetch​(long amount)` | Fetch the specified `amount` of elements.
    `MessageConsumer` | `getDelegate()` |
    `MessageConsumer<T>` | `handler​(Handler<Message<T>> handler)` | Set a data handler.
    `int` | `hashCode()` |
    `boolean` | `isRegistered()` |
    `static <T> MessageConsumer<T>` | `newInstance​(MessageConsumer arg)` |
    `static <T> MessageConsumer<T>` | `newInstance​(MessageConsumer arg, io.vertx.lang.rx.TypeArg<T> __typeArg_T)` |
    `MessageConsumer<T>` | `pause()` | Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `Pipe<Message<T>>` | `pipe()` | Pause this stream and return a to transfer the elements of this stream to a destination .
    `Completable` | `pipeTo​(WriteStream<Message<T>> dst)` | Pipe this `ReadStream` to the `WriteStream`.
    `MessageConsumer<T>` | `resume()` | Resume reading, and sets the buffer in `flowing` mode.
    `Completable` | `rxCompletion()` |
    `Completable` | `rxPipeTo​(WriteStream<Message<T>> dst)` | Pipe this `ReadStream` to the `WriteStream`.
    `Completable` | `rxUnregister()` | Unregisters the handler which created this registration
    `Flowable<Message<T>>` | `toFlowable()` |
    `Observable<Message<T>>` | `toObservable()` |
    `String` | `toString()` |
    `Completable` | `unregister()` | Unregisters the handler which created this registration

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<MessageConsumer> __TYPE_ARG

    - #### __typeArg_0

          public final io.vertx.lang.rx.TypeArg<T> __typeArg_0

  - ### Constructor Detail

    - #### MessageConsumer

          public MessageConsumer​(MessageConsumer delegate)

    - #### MessageConsumer

          public MessageConsumer​(Object delegate,
                                 io.vertx.lang.rx.TypeArg<T> typeArg_0)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public MessageConsumer getDelegate()

      Specified by:
        `getDelegate` in interface `ReadStream<T>`
      Specified by:
        `getDelegate` in interface `io.vertx.lang.rx.RxDelegate`
      Specified by:
        `getDelegate` in interface `StreamBase`

    - #### toObservable

          public Observable<Message<T>> toObservable()

      Specified by:
        `toObservable` in interface `ReadStream<T>`

    - #### toFlowable

          public Flowable<Message<T>> toFlowable()

      Specified by:
        `toFlowable` in interface `ReadStream<T>`

    - #### pipe

          public Pipe<Message<T>> pipe()

      Pause this stream and return a to transfer the elements of this stream to a destination .

      The stream will be resumed when the pipe will be wired to a `WriteStream`.
      Specified by:
        `pipe` in interface `ReadStream<T>`
      Returns:
        a pipe

    - #### pipeTo

          public Completable pipeTo​(WriteStream<Message<T>> dst)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Specified by:
        `pipeTo` in interface `ReadStream<T>`
      Parameters:
        `dst` - the destination write stream
      Returns:
        a future notified when the write stream will be ended with the outcome

    - #### rxPipeTo

          public Completable rxPipeTo​(WriteStream<Message<T>> dst)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Specified by:
        `rxPipeTo` in interface `ReadStream<T>`
      Parameters:
        `dst` - the destination write stream
      Returns:
        a future notified when the write stream will be ended with the outcome

    - #### exceptionHandler

          public MessageConsumer<T> exceptionHandler​(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<T>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          public MessageConsumer<T> handler​(Handler<Message<T>> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<T>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          public MessageConsumer<T> pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `ReadStream<T>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          public MessageConsumer<T> resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<T>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### fetch

          public MessageConsumer<T> fetch​(long amount)

      Description copied from interface: `ReadStream`
      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `ReadStream<T>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          public MessageConsumer<T> endHandler​(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<T>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### bodyStream

          public ReadStream<T> bodyStream()

      Returns:
        a read stream for the body of the message stream.

    - #### isRegistered

          public boolean isRegistered()

      Returns:
        true if the current consumer is registered

    - #### address

          public String address()

      Returns:
        The address the handler was registered with.

    - #### completion

          public Completable completion()

      Returns:
        a future notified when the message consumer is registered

    - #### rxCompletion

          public Completable rxCompletion()

      Returns:
        a future notified when the message consumer is registered

    - #### unregister

          public Completable unregister()

      Unregisters the handler which created this registration
      Returns:
        a future notified when the unregistation is done

    - #### rxUnregister

          public Completable rxUnregister()

      Unregisters the handler which created this registration
      Returns:
        a future notified when the unregistation is done

    - #### newInstance

          public static <T> MessageConsumer<T> newInstance​(MessageConsumer arg)

    - #### newInstance

          public static <T> MessageConsumer<T> newInstance​(MessageConsumer arg,
                                                           io.vertx.lang.rx.TypeArg<T> __typeArg_T)